=== debian/changelog ===
spoa (4.0.7+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 19 Jan 2021 07:33:42 +0100

spoa (4.0.6+ds2-2) unstable; urgency=medium

  * Team upload.
  * Only build-dep on libcpu-features-dev on i386/amd64.

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 13 Jan 2021 09:23:56 +0100
