=== debian/control ===
Source: spoa
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               d-shlibs,
               libbioparser-dev (>= 3.0),
               libcereal-dev,
               libgtest-dev,
               zlib1g-dev,
               libsimde-dev,
               libcpu-features-dev [any-amd64 any-i386]
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/spoa
Vcs-Git: https://salsa.debian.org/med-team/spoa.git
Homepage: https://github.com/rvaser/spoa
Rules-Requires-Root: no

Package: spoa
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: SIMD partial order alignment tool
 Spoa (SIMD POA) is a c++ implementation of the partial order alignment
 (POA) algorithm (as described in 10.1093/bioinformatics/18.3.452) which
 is used to generate consensus sequences (as described in
 10.1093/bioinformatics/btg109). It supports three alignment modes: local
 (Smith-Waterman), global (Needleman-Wunsch) and semi-global alignment
 (overlap).

Package: libspoa7.0.0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: SIMD partial order alignment library
 Spoa (SIMD POA) is a c++ implementation of the partial order alignment
 (POA) algorithm (as described in 10.1093/bioinformatics/18.3.452) which
 is used to generate consensus sequences (as described in
 10.1093/bioinformatics/btg109). It supports three alignment modes: local
 (Smith-Waterman), global (Needleman-Wunsch) and semi-global alignment
 (overlap).
 .
 This package contains the shared library.

Package: libspoa-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libspoa7.0.0 (= ${binary:Version}),
         libcereal-dev
Description: SIMD partial order alignment library (development files)
 Spoa (SIMD POA) is a c++ implementation of the partial order alignment
 (POA) algorithm (as described in 10.1093/bioinformatics/18.3.452) which
 is used to generate consensus sequences (as described in
 10.1093/bioinformatics/btg109). It supports three alignment modes: local
 (Smith-Waterman), global (Needleman-Wunsch) and semi-global alignment
 (overlap).
 .
 This package contains the static library and the header files.
