=== debian/watch ===
version=4

opts="repacksuffix=+ds,dversionmangle=auto,repack,compression=xz" \
 https://github.com/rvaser/spoa/releases .*/download/.*/spoa-v@ANY_VERSION@@ARCHIVE_EXT@
