=== debian/changelog ===
spoa (4.0.8-1) unstable; urgency=medium

  * Fix watch file
  * New upstream version
  * Upstream provides cmake instead of pkgconfig
  * Update symbols
  * No need to mention Files-Excluded any more

 -- Andreas Tille <tille@debian.org>  Tue, 29 Nov 2022 21:26:11 +0100

spoa (4.0.7+ds-3) unstable; urgency=medium

  * Standards-Version: 4.6.1 (routine-update)
  * lintian-override for false positive
  * Fix symbols file to work with gcc-12
    Closes: #1016293

 -- Andreas Tille <tille@debian.org>  Thu, 04 Aug 2022 14:24:59 +0200

spoa (4.0.7+ds-2) unstable; urgency=medium

  * Team upload.
  * Packaging update
  * Standards-Version: 4.6.0 (routine-update)
  * Freshen symbols for GCC 11. Closes: #984348

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 15 Oct 2021 13:46:21 +0200
