=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                zlib1g-dev,
                libsimde-dev,
                libcpu-features-dev [any-amd64 any-i386]
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/spoa
 Vcs-Git: https://salsa.debian.org/med-team/spoa.git
 Homepage: https://github.com/rvaser/spoa
