=== debian/rules ===
--- 
+++ 
@@ -33,7 +33,7 @@
 		    --exclude-la \
 		    --exclude-a \
 		    --movedev debian/tmp/usr/include/spoa usr/include \
-		    --movedev debian/tmp/usr/lib/*/pkgconfig usr/lib/$(DEB_HOST_MULTIARCH) \
+		    --movedev debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/cmake /usr/lib/${DEB_HOST_MULTIARCH} \
 		    debian/tmp/usr/lib/*/*.so
 
 override_dh_auto_test:
