## spoa 4.1.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,22 +1,13 @@
 cmake_minimum_required(VERSION 3.12)
 
-project(spoa VERSION 4.0.8
+project(spoa VERSION 4.1.4
              LANGUAGES CXX
              DESCRIPTION "Spoa is a c++ library (and tool) for SIMD vectorized partial order alignment.")
 
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic")
-set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
-
-if (${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
-  if (${CMAKE_CXX_COMPILER_VERSION} VERSION_GREATER_EQUAL "5.0.0")
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-aligned-new")
-  endif ()
-  if (${CMAKE_CXX_COMPILER_VERSION} VERSION_GREATER_EQUAL "6.1.0")
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-ignored-attributes")
-  endif ()
-endif ()
 
 set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
 set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
@@ -55,7 +46,7 @@
   FetchContent_Declare(
     simde
     GIT_REPOSITORY https://github.com/simd-everywhere/simde
-    GIT_TAG v0.7.0)
+    GIT_TAG v0.7.6)
 
   FetchContent_GetProperties(simde)
   if (NOT simde_POPULATED)
@@ -125,14 +116,14 @@
 endif ()
 
 if (spoa_build_exe OR spoa_build_tests)
-  find_package(bioparser 3.0.13 QUIET)
-  find_package(biosoup 0.10.0 QUIET)
+  find_package(bioparser 3.1.0 QUIET)
+  find_package(biosoup 0.11.0 QUIET)
 
   if (NOT bioparser_FOUND)
     FetchContent_Declare(
       bioparser
       GIT_REPOSITORY https://github.com/rvaser/bioparser
-      GIT_TAG 3.0.13)
+      GIT_TAG 3.1.0)
 
     FetchContent_GetProperties(bioparser)
     if (NOT bioparser_POPULATED)
@@ -148,7 +139,7 @@
     FetchContent_Declare(
       biosoup
       GIT_REPOSITORY https://github.com/rvaser/biosoup
-      GIT_TAG 0.10.0)
+      GIT_TAG 0.11.0)
 
     FetchContent_GetProperties(biosoup)
     if (NOT biosoup_POPULATED)
@@ -180,16 +171,21 @@
     endif ()
   endif ()
 endif ()
+
+set(SPOA_VERSION "${PROJECT_VERSION}")
+configure_file(src/spoa_config.h.in spoa_config.h)
 
 add_library(spoa
   src/alignment_engine.cpp
   src/graph.cpp
   src/simd_alignment_engine_dispatcher.cpp
-  src/sisd_alignment_engine.cpp)
+  src/sisd_alignment_engine.cpp
+  src/version.cpp)
 add_library(spoa::spoa ALIAS spoa)
 
 target_include_directories(spoa PUBLIC
   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
+  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
   $<BUILD_INTERFACE:${simde_SOURCE_DIR}>
   $<INSTALL_INTERFACE:include>)
 
@@ -267,13 +263,15 @@
     bioparser::bioparser
     biosoup::biosoup)
 
-  target_compile_definitions(spoa_exe PRIVATE VERSION="${PROJECT_VERSION}")
   set_property(TARGET spoa_exe PROPERTY OUTPUT_NAME spoa)
 
   install(TARGETS spoa_exe DESTINATION ${CMAKE_INSTALL_BINDIR})
 endif ()
 
 if (spoa_build_tests)
+  set(SPOA_TEST_DATA "${PROJECT_SOURCE_DIR}/test/data/sample.fastq.gz")
+  configure_file(test/spoa_test_config.h.in spoa_test_config.h)
+
   add_executable(spoa_test
     test/spoa_test.cpp)
 
@@ -283,6 +281,6 @@
     biosoup::biosoup
     GTest::Main)
 
-  target_compile_definitions(spoa_test
-    PRIVATE TEST_DATA="${PROJECT_SOURCE_DIR}/test/data/sample.fastq.gz")
-endif ()
+  target_include_directories(spoa_test PUBLIC
+    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>)
+endif ()
