=== debian/changelog ===
spoa (4.1.4-2) unstable; urgency=medium

  * d/libspoa7.0.0.symbols.amd64: mark some compiler symbols as optional.
    (Closes: #1075532)
  * d/control: add myself to uploaders.
  * d/control: declare compliance to standards version 4.7.0.

 -- Étienne Mollier <emollier@debian.org>  Wed, 24 Jul 2024 21:59:08 +0200

spoa (4.1.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * Refresh patches.
  * d/rules: set optimize=-lto. Closes: #1015667
  * d/libspoa7.0.0.symbols.amd64: add new symbols.
  * d/source/lintian-overrides: removed, no longer needed.

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 21 Mar 2024 12:34:13 +0100
