=== debian/control ===
--- 
+++ 
@@ -1,18 +1,19 @@
 Source: spoa
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Andreas Tille <tille@debian.org>
+Uploaders: Andreas Tille <tille@debian.org>,
+           Étienne Mollier <emollier@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                cmake,
                d-shlibs,
-               libbioparser-dev (>= 3.0),
+               libbioparser-dev,
                libcereal-dev,
                libgtest-dev,
                zlib1g-dev,
                libsimde-dev,
                libcpu-features-dev [any-amd64 any-i386]
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/spoa
 Vcs-Git: https://salsa.debian.org/med-team/spoa.git
 Homepage: https://github.com/rvaser/spoa
