=== debian/changelog ===
spoa (4.1.5-1) unstable; urgency=medium

  * New upstream version 4.1.5
  * d/*symbols*: mark few leaked symbols as optional. (Closes: #1097922)
  * d/control: declare compliance to standards version 4.7.2.
  * d/control: drop redundant Rules-Requires-Root: no.
  * d/watch: convert to v5 Github template.
  * d/patches/*: normalize Last-Update timestamp.
  * d/*symbols*: add a couple of optional leaked symbols.

 -- Étienne Mollier <emollier@debian.org>  Wed, 08 Oct 2025 22:24:58 +0200
