=== debian/control ===
--- 
+++ 
@@ -13,11 +13,10 @@
                zlib1g-dev,
                libsimde-dev,
                libcpu-features-dev [any-amd64 any-i386]
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/spoa
 Vcs-Git: https://salsa.debian.org/med-team/spoa.git
 Homepage: https://github.com/rvaser/spoa
-Rules-Requires-Root: no
 
 Package: spoa
 Architecture: any
