=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,8 @@
 
 include /usr/share/dpkg/default.mk
 
-export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all optimize=-lto
 export DEB_CXXFLAGS_MAINT_APPEND=-O3
 
 DEB_CMAKE_EXTRA_FLAGS = -DCMAKE_BUILD_TYPE=Release \
