=== debian/watch ===
Version: 5

Template: Github
Owner: rvaser
Project: spoa
Dversionmangle: auto
Repacksuffix: +ds
